if ( CLIENT ) then
killicon.Add(  "old_bonnie_2", "overlays/fivenights_bonnie/old_bonniedeath", Color( 255, 80, 0, 255   ) )
language.Add("old_bonnie_2", "Withered Bonnie")
end
AddCSLuaFile()
ENT.Type			= "anim"
ENT.Base 			= "fnaf2_ent_base"
ENT.Spawnable		= true
ENT.AdminSpawnable  = true
ENT.PrintName		= "Withered Bonnie"
ENT.Category 		= "Five Nights at Freddy's 2A"
ENT.RenderGroup 	= RENDERGROUP_TRANSLUCENT
ENT.Model = "models/smoke/FiveNightsAtFreddys/bennie_new.mdl"
ENT.IdleAnim = "idle"
ENT.DeathRagdoll = "models/smoke/FiveNightsAtFreddys/bennie_new.mdl"
local sndStab = Sound( "legitfreddy2/xscream2.wav" )

local THINK_DELAY = 0

local TELEPORT_PROB = 0.09
local TELEPORT_COOLDOWN = 0.02
local TELEPORT_MAX_DIST = 3000
local TELEPORT_MAX_DIST_FROM_PLR = 450
local TELEPORT_MIN_DIST_FROM_PLR = 130
local TELEPORT_MAX_TRIES = 20

local CREEP_PROB = 1
local CREEP_COOLDOWN = 1.6
local CREEP_DISTANCE_FRACTION = 0.6

local STAB_MAX_DIST = 120
local STAB_PROB = 0.1
local STAB_COOLDOWN = 2
local STAB_FORCE = 12000
local STAB_DAMAGE = 500

local EMITSOUND_MAX_DIST = 2200
local EMITSOUND_PROB = 0.008
local EMITSOUND_COOLDOWN = 4


if (SERVER) then
		function ENT:Initialize()
		self:SetHealth(500)
		self.ScareNoise = {
		Sound("legitfreddy2/ventwalk1.wav"),
		Sound("legitfreddy2/walk1.wav"),  
		Sound("legitfreddy2/walk2.wav"),
		Sound("legitfreddy2/walk3.wav"),
		Sound("legitfreddy2/walk4.wav"),  
		Sound("legitfreddy2/walk5.wav"),
		Sound("legitfreddy2/fansound.wav"),
		Sound("legitfreddy2/popstatic.wav"),
		Sound( "legitfreddy2/With_S2.wav"),
		Sound("legitfreddy2/CMPTR_Low_Tech_Stat.wav")}
		--self:DropToFloor()
		self:EmitSound("legitfreddy/robotvoice.wav", 50, 100)
		timer.Create( "robot", 15, 0, function()
		if !IsValid(self) then return end
		self:EmitSound("legitfreddy/robotvoice.wav", 50, 100)
		end)
		timer.Create( "scare sound", 15, 0, function()
		if !IsValid(self) then return end
		if GetConVarNumber("fnaf2_scare_off") == 0 then
		self:EmitSound(self.ScareNoise[math.random(#self.ScareNoise)])
		else
		end
		end)
		self:EmitSound("legitfreddy2/stare.wav", 500, 100)
		self:SetModel( self.Model )
		self:SetCollisionGroup( COLLISION_GROUP_WEAPON )
		local h_offset = 14.9
		local h = 30
		local l = 20
		local w = 15
		local phys = self:GetPhysicsObject()
		self:SetSolid( SOLID_BBOX )
		self:SetMoveType(MOVETYPE_VPHYSICS)
		local phys = self:GetPhysicsObject()
		self.Width = self:BoundingRadius() * 0.5
		self.CurSound = nil
		self.NextTeleport = 0
		self.NextCreep = 0
		self.NextEmit = 0
		self.NextStab = 0
		self.IsBeingCreepy = false
		self.AutomaticFrameAdvance = true 	
		local edata = EffectData()
		edata:SetStart(self:GetPos())
		edata:SetOrigin(Vector(self:GetPos().x, self:GetPos().y, self:GetPos().z + 50))
		edata:SetNormal(self:GetPos())
		edata:SetScale(1)
		edata:SetEntity(self)
		edata:SetMagnitude( 0.36 )
		edata:SetRadius( 2 )
        util.Effect("Sparks", edata)
		
		timer.Create( "sparks", 3, 0, function()
		if !IsValid(self) then return end
		local edata = EffectData()
		edata:SetStart(self:GetPos())
		edata:SetOrigin(Vector(self:GetPos().x, self:GetPos().y, self:GetPos().z + 50))
		edata:SetNormal(self:GetPos())
		edata:SetScale(1)
		edata:SetEntity(self)
		edata:SetMagnitude( 0.36 )
		edata:SetRadius( 2 )
		util.Effect("Sparks", edata)
		end)
	end

else

	function ENT:Initialize()
--	local sequence = self:LookupSequence("run")
--self:SetSequence(sequence)
--	self:SetCycle( 0 )
--	self:ResetSequence( sequence )
--	self:SetPlaybackRate( 0	 )
--	self:SetCycle( 0 )
--self.AutomaticFrameAdvance = true 
	end
end

function ENT:OnRemove()
if !IsValid(self.Victim) then return end
self.Victim:ConCommand( "pp_mat_overlay  " )
timer.Destroy("freakout")
timer.Destroy("notice")
timer.Destroy("scare undo")
timer.Destroy("scare undo2")
timer.Destroy("scare undo3")
timer.Destroy("death2")
timer.Destroy("stare")
timer.Destroy("neardeath")
timer.Destroy( "robot" )
timer.Destroy( "scare sound" )
timer.Destroy( "static_undo" )
timer.Destroy( "sparks" )
end

function ENT:StabbyLunge( vec )
if GetConVarNumber("ai_disabled") == 0 then
	if GetConVarNumber("fnaf2_scare_off") == 0 then
	if !IsValid(self) then return end
		local sequence = self:LookupSequence("run")
self:SetSequence(sequence)
	self:SetCycle( 0 )
	self:ResetSequence( sequence )
	self:SetPlaybackRate( 0	 )
	self:SetCycle( 0 )
self.AutomaticFrameAdvance = true 

	self:EmitSound( sndStab, 500, 100 )
	self:SetRenderMode(RENDERMODE_TRANSALPHA)
	self:SetColor(Color(255, 255, 255, 1))
	self.Victim:ConCommand( "pp_mat_overlay overlays/fivenights_bonnie/old_bonniedeath" )

	--if GetConVarNumber("fnaf2_spawn_table") == 1 then
	--local ents = ents.Create( "freddy_table" )
	--ents:SetPos(self.Victim:GetPos())
	--ents:SetAngles(self.Victim:GetAngles())
	--ents:Spawn()
	--undo.Create("Freddy Table") 		
	--undo.AddEntity(ents) for k,v in pairs( player.GetAll()) do undo.SetPlayer(v) 
	--end 	
	--undo.Finish()	
	if GetConVarNumber("fnaf2_keep_bodies") == 0 then
	timer.Create( "removebody", 10, 1, function()
	if !IsValid(ents) then return end
	ents:Remove()
	end)
	else
	end
	else
	end
	timer.Create( "freakout undo", 1, 1, function()
	if !IsValid(self.Victim) then return end
	--self.Victim:ConCommand( "pp_mat_overlay  " )
	--self.Victim:SendLua([[RunConsoleCommand("stopsound")]])
	--self:EmitSound( sndStab, 500, 100 )
	end)
	timer.Create( "freakout undo2", 1.2, 1, function()
	if GetConVarNumber("fnaf2_scare_off") == 0 then
	if !IsValid(self) then return end
	if !IsValid(self.Victim) then return end
	self:EmitSound( "legitfreddy/static.wav" )
	self.Victim:ConCommand( "pp_mat_overlay overlays/fivenights_static/static2" )
	self:SetRenderMode(RENDERMODE_TRANSALPHA)
	self:SetColor(Color(255, 255, 255, 255))
		local sequence = self:LookupSequence("idle")
self:SetSequence(sequence)
	self:SetCycle( 0 )
	self:ResetSequence( sequence )
	self:SetPlaybackRate( 0	 )
	self:SetCycle( 0 )
self.AutomaticFrameAdvance = true
	end
	end)
	timer.Create( "static_undo", 3, 1, function()
	if !IsValid(self) then return end
	if !IsValid(self.Victim) then return end
	--self.Victim:SendLua([[RunConsoleCommand("stopsound")]])
	self.Victim:ConCommand( "pp_mat_overlay  " )
	newtarget = player.GetAll()[math.random(1,#player.GetAll())]
	self:SetVictim( newtarget )
	end)
	timer.Create( "freakout undo3", 5, 1, function()
	if !IsValid(self.Victim) then return end
	--self.Victim:SendLua([[RunConsoleCommand("stopsound")]])
	end)
	if CurTime() < self.NextStab then return end
	local stabvec = vec * STAB_FORCE + Vector( 0, 0, 0.4 * STAB_FORCE )
	local vicpos = self.Victim:GetShootPos()
	self.Victim:TakeDamage( STAB_DAMAGE, self )


	self.NextStab = CurTime() + STAB_COOLDOWN
	else
		if !IsValid(self) then return end
		local sequence = self:LookupSequence("run")
self:SetSequence(sequence)
	self:SetCycle( 0 )
	self:ResetSequence( sequence )
	self:SetPlaybackRate( 0	 )
	self:SetCycle( 0 )
		timer.Create( "freakout undo", 1, 1, function()
	if !IsValid(self.Victim) then return end
	self.Victim:ConCommand( "pp_mat_overlay  " )
	newtarget = player.GetAll()[math.random(1,#player.GetAll())]
	self:SetVictim( newtarget )
	end)
	timer.Create( "freakout undo2", 1.2, 1, function()
		if !IsValid(self) then return end
	local sequence = self:LookupSequence("idle")
self:SetSequence(sequence)
	self:SetCycle( 0 )
	self:ResetSequence( sequence )
	self:SetPlaybackRate( 0	 )
	self:SetCycle( 0 )
self.AutomaticFrameAdvance = true 
	if !IsValid(self.Victim) then return end
	--self:EmitSound( "legitfreddy/static.wav" )
	end)
	timer.Create( "freakout undo3", 5, 1, function()
	if !IsValid(self.Victim) then return end
	end)
	if CurTime() < self.NextStab then return end
	local stabvec = vec * STAB_FORCE + Vector( 0, 0, 0.4 * STAB_FORCE )
	local vicpos = self.Victim:GetShootPos()
	self.Victim:TakeDamage( STAB_DAMAGE, self )
	self.NextStab = CurTime() + STAB_COOLDOWN
	end
end
